#include "mv.h"

/* const and restrict don't help much because the inner loop is one
   of load from pointer, accumulate into register */
void mv_( const int * restrict ia, const int * restrict ja, 
          const int * restrict ka,  
          const double * const restrict a, 
          const double * const restrict x, double * restrict y, 
          const int * restrict n_ptr )
{
  double     sum;
  int        i, jrow,j,ncol,shift,n=*n_ptr;
  const double * const restrict x1 = x - 1;

  /* x    = x + shift; */ 
  shift = 1; /* shift for Fortran start by 1 indexing */
  /*x = x - shift; */
  for ( i=0; i<n; i++ ) {
    jrow = ia[i];
    ncol = ia[i+1] - jrow;
    jrow = jrow - shift;
    sum  = 0.0;
    /* while (ncol--) sum += *v++ * x[*ja++]; */
    for ( j=0; j<ncol; j++) {
      sum += a[jrow]*x1[ja[jrow]]; jrow++;
     }
    y[i] = sum;
  }
}

int mvextra_( ia, ja, a, n_ptr )
int *ia, *ja, *n_ptr;
double *a;
{
    return 0;
}

void mvsetup_( ia, ja, ka, a, n_ptr )
int *ia, *ja, *ka, *n_ptr;
double *a;
{
    /* Nothing to do in the simple version */
}

void mvname_( str, ln )
char *str;
int  ln;
{
    strncpy( str, "C Simple AIJ", ln - 1 );
}

#ifndef FLAGS
#define FLAGS "Unknown"
#endif
void mvflags_( str, ln )
char *str;
int  ln;
{
    strncpy( str, FLAGS, ln - 1 );
}
